/* vim: set sw=3 ts=3 sts=3 expandtab: */
#ifndef ECDB_H
#define ECDB_H

#include "config.h"
#include <Evas.h>
#include <Edje.h>
#include <Ecore.h>
#include <Ecore_Data.h>
#include <Ecore_File.h>
#include <Ecore_Evas.h>
#include <Ecore_Str.h>
#include <Ecore_X.h>
#include <Eina.h>
#include <Efreet_Mime.h>
#include <Efreet.h>
#include <Ewl.h>
#include <libburn/libburn.h>
#include <libisofs/libisofs.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include <limits.h>
#include <pthread.h>

/* ECDB Global Variables */
typedef struct _Ecdb_Main Ecdb_Main;
struct _Ecdb_Main
{
   char theme_path[PATH_MAX];
   Ecore_Evas *main_win_ee;
   Ecore_List *drives;
   Ecore_List *dnd_candidates;
   Evas_Object *drop_object;
};

extern Ecdb_Main *em;

/* Callbacks */
extern int ECDB_DRIVE_ACTION_FINISHED;
extern int ECDB_DRIVE_ACTION_BEGUN;
extern int ECDB_DRIVE_ACTION_UPDATE;

#include "ecdb_common.h"
#include "ecdb_drives.h"
#include "ecdb_image.h"
#include "ecdb_burn.h"
#include "ecdb_erase.h"
#include "ecdb_misc.h"
#include "ecdb_audio.h"
#include "ecdb_gui.h"

#endif

